unit ldn032u1;

//Work on stuff that happens when app starts with "bad" portnum, adaptertype or ChipID

//SOON: Do funcs to "hide" details of TMOneWireLevel in tmex_support.

//(later... a tidy) see qFind16823b

//Can be hard to get out of, if reading repeatedly.

//(later... handle bad schip designated) Tidy "//THIS (27 Aug 16, 22:08)needs work"

//still problematic if TTRW set to 6000.

//Add count of events, prefix to msg in msg windows(maybe not Verbose... it
//   has seconds
//... so scrolling of repeated events can be seen, if for no other reason.

//explain genesis/ relation to LDN030... here, and in tut for 32 when
//  done.

//HAS PROBLEM in what happens if you change TT RW "on the fly".
//AND... separate issue?....6000 cripples it. Beware too large, too small values passing
//to underlying variable during adjustment-making.
//AND if in ReadRepeatedly, "saves up" error messages, at least sometimes...
//  those relating to checksum errors, I think it was, at least.
//Maybe "just" (klugde?) put an application.process messages in with
//  and post to memo?

//At 27 Aug 16, 09:43, I'd moved to 2nd gen WaitABit, hoping to elim lag
//if trying to scroll while app in WaitABit... and 2nd Gen didn't work
//either... although, moving to sleep DID (I think) fix lagginess on the
//part of OTHER apps sharing the PC...

//HAS FLAW (at the moment (23 Aug 16) I partly fixed it, at least. Maybe
//since then I completely fixed it, and forgot to take this
//note out! If you click the "Quit" button while a conversion is going on,
//the program doesn't quit immediately. but as soon as the conversion
//is over, the "Quit" you tried to invoke will happen. Sorry.
//This may well be a consequence of my dubious "WaitABit" routine.
//It was WORSE before I replace my attempt with the one based on the
//built in "sleep" procedure. That seems to work quite well, apart from
//the little annoyance mentioned. But I haven't used "sleep" before...
//there may be other consequences I don't know about.

//ANOTHER FLAW... more easily fixed... If ini file doesn't hold good values
//when you try to start, the dealing with that is clumsy. Also, it wouldn't
//be obvious to a user that changing values for port number, adapter or chip
//in the edit boxes would have no effect until program RESTARTED.

//The "wait to quit" "problem" could probably be solved by acheiving the
//"long" sleeps the program needs (1200ms or so) by doing several
//shorter executions with short "sleeps"

//============================
//CURRENTLY--- working on building tmex_suport unit, in particular a
//record returning TMTouchByte. Also, "error messages" function(s).. there.

//This sourcecode demonstrates accessing a Dallas 1-Wire temperature
//   sensor, the DS18B20.
//It is an enhanced version of LDN031, which did more or less what
//   this does, more transparently, less elegantly.
//LDN031 is the subject of a tutorial on using Lazarus for Dallas
//   1-Wire / MicroLan/ TMEX....
//The story started at LDN030, subject of its own tutorial...
//http://sheepdogguides.com/lut/dstl2hello_ds18b20.htm
//... and can be downloaded from a link there.

//A little TMEX "gtocha": TMTouchByte returns a byte, if called
//with $FF in outbyte. The TMEX API Help states that it
//will return $FF if MicroLan shorted.
//
//But! I believe that $FF must not be treated as
//"an error" uncritically... there may be times when the
//chip you went off to read sends you VALID DATA consisting
//of $FF.

//For the future... create an "IsMicroLanShorted" funcion. If
//   TMTouchByte($FF) returns $FF, it MAY be because MicroLan is
//   shorted... or it may simply be that the chip you are talking
//   to is currently sending an $FF.

{$mode objfpc}

{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Inifiles, iBTMEXPW, TtureConversions, smallhelpers, tmex_support,
  readings_window;

const vers='29 Aug 16**B**';
      //LDN032 is an enhanced version of LDN031. LDN032 started 23 Aug 16
      kIniFileName='LDN032ini.txt';
      kBuLableReadRepeatedlyTurnOn='Read Tture Repeatedly';
      kBuLableReadRepeatedlyTurnOff='Stop Reading Repeatedly';
      kCyclesRoot='Cycles done:';
      kMinWaitBetween=800;//Minimum wait, ms, between "convert", and
          //"read value" for DS18B20
      //Four possible "values" for first parameter of PostTwoStrings...
         kP2neit=0;//Send to neither
         kP2conc=1;//Send only to concise
         kP2verb=2;//Send only to verbose
         kP2both=3;//Send to both


(*This software, at 26 Aug 16, was only good to read
a DS18B20 (family code $28). "Turning on" the "read family
code $10" parts probably trivial... but I didn't have a
$10 chip to hand!

The free "1-Wire Viewer" which comes with the TMEX
software is valuable in several ways, not least for
telling me the chip's ID. It said "2E00.0001.34D9.E328",
but the dots in that mean nothing more than the commas
in, say, 1,432,376, or the dashes in a telephone number,
e.g. 1-888-555-1212. They are there only to aid
readabilty.*)

type

  { Tldn032f1 }

  Tldn032f1 = class(TForm)
    buQuit: TButton;
    buTakeTture: TButton;
    buTmpTestThing: TButton;
    buReadRepeatedlyToggle: TButton;
    buTryGetGoing: TButton;
    cbShowRawValues: TCheckBox;
    eChipID0: TEdit;
    eAdapterType: TEdit;
    eWaitBetweenHalvesOfTtureRead: TEdit;
    ePortNum: TEdit;
    eSecsBtwReads: TEdit;
    laBadFlaw: TLabel;
    laBadFlaw1: TLabel;
    laEWaitBetweenMsg: TLabel;
    laCycles: TLabel;
    laChipID0b: TLabel;
    laESecsBtwReads: TLabel;
    laPortNum: TLabel;
    laChipID0a: TLabel;
    laAdapterType: TLabel;
    laWaitBetweenHalvesOfTtureRead: TLabel;
    laThreeConstTweak: TLabel;
    laTutsURL: TLabel;
    laDebug: TLabel;
    laWaitBetweenHalvesOfTtureRead1: TLabel;
    meMsgsConcise: TMemo;
    meMsgs: TMemo;
    tiReadRepeatedly: TTimer;
    tiWaitTimer: TTimer;//tiWaitTimer...
    //** Copy 1 of 2 of this note... keep them in step.
    //tiWaitTimer was used by WaitABit. There, it provides/ provided
    //a long (in computer terms) "time out" between the
    //execution of two blocks of code. It is probably
    //a bad way to do this. Would a TIdleTimer be
    //the way to go?
    procedure buQuitClick(Sender: TObject);
    procedure buReadRepeatedlyToggleClick(Sender: TObject);
    procedure buTakeTtureClick(Sender: TObject);
    procedure buTmpTestThingClick(Sender: TObject);
    procedure buTryGetGoingClick(Sender: TObject);
    procedure eAdapterTypeChange(Sender: TObject);
    procedure eChipID0Change(Sender: TObject);
    procedure ePortNumChange(Sender: TObject);
    procedure eSecsBtwReadsChange(Sender: TObject);
    procedure eWaitBetweenHalvesOfTtureReadChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure tiReadRepeatedlyTimer(Sender: TObject);
    procedure tiWaitTimerTimer(Sender: TObject);


  private
    { private declarations }
    //I have split things between "private" and "public"
    //   rather haphazardly.
    bTmp:byte;
    boTmp,boSessionValid,boGoodChipID0,boReadingRepeatedly,
      boStartParamsOkay:boolean;
    wWaitBetweenHalvesOfTtureRead,wSecsBtwReads:word;
    udrTMExtenStrtSessPlusTMSetupTmp:TudrTMExtenStrtSessPlusTMSetup;
    udrReadScratchpadTmp:TudrReadScratchpad;
    liTmp,liEvents:longint;//(Explained where init'd in FormCreate handler
    function TakeTTureReading:longint;
    procedure WaitABit(wMS:word);
    procedure WaitBriefly(wMS:word);
    procedure PostTwoStrings(bSw:byte;udrTwoStrings_tmpL:TudrTwoStrings);
    procedure IncCylesAndReDisplay;
    function boTryToStart(var liTmpL:longint):boolean;
    procedure SwitchOptionsForReading(bOneForOn_ZeroForOff:byte);
    procedure DisplayTtureReading(liTmpL:longint);

  public
    { public declarations }
    liCycles:longint;
    sTmp:string;
    wTmp:word;
    sChipID: array[0..1] of string[20];//Array to allow for
      //future enhancements. Only element 0 in use in LDN032
    liSessHdl:longint;//32-bits, treated as
        //a signed integer (negative 2 billion or so
        //   (10 to the power 9) to positive 2 billion or so)
    siTmp,siPortNum,siAdapterType:smallint;//16-bits, treated as
        //a signed integer (-32768 to +32767)
        //DON'T CONFUSE "smallint" and "shortint"!)
    siWaitABitTimeouts:smallint;//used only as part of WaitABit,
        //with tiWaitTimer.
    udrTmpTryTmex0:TudrTryTmex0;
    udrTwoStrings_tmp,udrTwoStrings_tmp2:TudrTwoStrings;
    udrTMEXROMTmp:TudrTMEXROM;

    procedure PostConcise(sTmpL:string);

  end;

var
  ldn032f1: Tldn032f1;

implementation

{$R *.lfm}

{ Tldn032f1 }



//===== Button, Edit Box, etc Events... Click, Change, etc. ==========

procedure Tldn032f1.buTmpTestThingClick(Sender: TObject);
//this button doesn't do anything "important"... it is a scrap
//of my ongoing work on this project. I can put things in
//this event handler as a "cheap and cheerful" way to see what they do.

begin
  showmessage('Does nothing at moment... 28 Aug 16, 12:04... could be re-'+
     'purposed.')
end;

procedure Tldn032f1.buTryGetGoingClick(Sender: TObject);
begin
  boStartParamsOkay:=boTryToStart(liSessHdl);
  if boStartParamsOkay then begin
       //turn on subsequent actions,
       //remove "fix it" message
       SwitchOptionsForReading(1);//turn ON
       end//no ; here
      else begin
       //turn off subsequent actions
       //insert "fix it" message
       SwitchOptionsForReading(0);//turn OFF
       end;//"else" of if boStartParamsOkay...

    meMsgs.lines.insert(0,'PortNum and/or AdapterType changed.');
end;

procedure Tldn032f1.buTakeTtureClick(Sender: TObject);
begin
  IncCylesAndReDisplay;
  application.processmessages;
  liTmp:=TakeTTureReading;
  DisplayTtureReading(liTmp);
end;

procedure Tldn032f1.buQuitClick(Sender: TObject);
begin
  close;
end;

procedure Tldn032f1.buReadRepeatedlyToggleClick(Sender: TObject);
//Toggle all that needs to be toggled to switch between
//  taking readings repeatedly, and not doing so.
//How often a reading is taken is determined by the interval
//  set for tiReadRepeatedly. I'd keep it above 2999.
//In long term operation, the memos will eventually fill... but
//  they can hold, I think, 65,00 lines, so for the purposes of
//  this DEMO program, the mechanisms in place are fine.
//  If you want to leave the app monitoring ttures for weeks
//  on end, something will need to be done to deal with memos
//  getting "full"... I think. (They may have a mechanism for
//  "throwing away" excess lines... but I'd rather program in
//  the mechanism to deal with that, rather than rely on
//  someone else's throughness.)
begin
  if boReadingRepeatedly then begin
     boReadingRepeatedly:=false;
     buReadRepeatedlyToggle.Caption:=kBuLableReadRepeatedlyTurnOn;
     //insert here... msgs to eventslog... 1 of 2
     tiReadRepeatedly.enabled:=false;
     buTakeTture.enabled:=true;
  end//no ; here
  else begin
     IncCylesAndReDisplay;//This is an "extra" one, and count will
     //be high by 1 for each time you (re-)start ReadRepeatedly.
     //Without it, you have no confirmation (other than button label
     //change) that you've gone into ReadRepeatedly. It is intuitive
     //that you SHOULD see cycle count go up immediately, and the
     //EXACT number of cycles not critical.
     //(Once into reading repeatedly, there is a "stutter", inelegant
     //offset between change of cycles count and new entry in
     //reports of tture readings. Possibly fixing that would also
     //eliminate the need for this "extra" IncCycles...
     application.processmessages;//to get result of Inc.. to display
     //before the slight lag at start of "TakeAndDisplay..."
     liTmp:=TakeTtureReading;//Do one "by hand", immediately, so
     //user knows that the taking of readings has started.
     //Otherwise first reading isn't until end of first timeout.
     boReadingRepeatedly:=true;
     buReadRepeatedlyToggle.Caption:=kBuLableReadRepeatedlyTurnOff;
     //insert here... msgs to eventslog... 2 of 2
     tiReadRepeatedly.Interval:=wSecsBtwReads*1000;
     tiReadRepeatedly.enabled:=true;
     buTakeTture.enabled:=false;
  end;//of else of "if boReadingRepeatedly..."
end;

procedure Tldn032f1.eAdapterTypeChange(Sender: TObject);
begin
if buReadRepeatedlyToggle.caption=kBuLableReadRepeatedlyTurnOff
       then buReadRepeatedlyToggleClick(self);
SwitchOptionsForReading(0);
try
  siAdapterType:=StrToInt(eAdapterType.text);
  except
  end;//try.. except
end;//eAdapterTypeChange

procedure Tldn032f1.ePortNumChange(Sender: TObject);
begin
if buReadRepeatedlyToggle.caption=kBuLableReadRepeatedlyTurnOff
       then buReadRepeatedlyToggleClick(self);
SwitchOptionsForReading(0);
try
  siPortNum:=StrToInt(ePortNum.text);
  except
  end;//try.. except
end;//ePortNumChange

procedure Tldn032f1.eChipID0Change(Sender: TObject);
//Yes! I realize that this routine is not well written!
var bCount:byte;
    sTmpL,sTmpLMinusDecimals:string;
begin
boGoodChipID0:=true;
sChipID[0]:=eChipID0.text;
sTmpLMinusDecimals:='';
for bCount:=1 to length(sChipID[0]) do begin
    if sChipID[0,bCount]<>'.' then
          sTmpLMinusDecimals:=sTmpLMinusDecimals+sChipID[0,bCount];
    end;//for...
//showmessage(sTmpLMinusDecimals);
if length(sTmpLMinusDecimals)<>16 then
  begin
    boGoodChipID0:=false;
    end//no ; here
  else begin
    for bCount:=1 to 16 do begin
       sTmpL:=uppercase(sTmpLMinusDecimals[bCount]);
       if pos(sTmpL,'0123456789ABCDEF')=0 then boGoodChipID0:=false;
       end;//for
    end;//else
sChipID[0]:=sTmpLMinusDecimals;
//SeeIfTimeToEnableReadChip;
end;//eChipIDChange

procedure Tldn032f1.eSecsBtwReadsChange(Sender: TObject);
begin
try
  wSecsBtwReads:=
          StrToInt(eSecsBtwReads.text);
  except
  //
  end;//try.. except
  if wWaitBetweenHalvesOfTtureRead<1 then begin
    wWaitBetweenHalvesOfTtureRead:=1;
    eWaitBetweenHalvesOfTtureRead.text:=inttostr(wWaitBetweenHalvesOfTtureRead);
  end;
end;//eSecsBtwReadsChange

procedure Tldn032f1.eWaitBetweenHalvesOfTtureReadChange(Sender: TObject);
begin
//boGoodPortNumber:=true;
try
  wWaitBetweenHalvesOfTtureRead:=
          StrToInt(eWaitBetweenHalvesOfTtureRead.text);
  except
  //boWaitBetweenHalvesOfTtureRead:=false;
  end;//try.. except
//SeeIfTimeToEnableReadChip;
  if wWaitBetweenHalvesOfTtureRead<kMinWaitBetween then begin
  eWaitBetweenHalvesOfTtureRead.text:=inttostr(kMinWaitBetween);
  end;
end;//ePortNumChange

procedure Tldn032f1.tiReadRepeatedlyTimer(Sender: TObject);
begin
  IncCylesAndReDisplay;
  application.processmessages;
  liTmp:=TakeTtureReading;
  DisplayTtureReading(liTmp);
end;

procedure Tldn032f1.tiWaitTimerTimer(Sender: TObject);
//** Copy 2 of 2 of this note... keep them in step.
//tiWaitTimer was used by WaitABit. There, it provides/ provided
//a long (in computer terms) "time out" between the
//execution of two blocks of code. It is probably
//a bad way to do this. Would a TIdleTimer be
//the way to go?
begin
  dec(siWaitABitTimeouts);
  application.processmessages;//Essential.?.. prgm
  //may freeze if you try to quit while in this loop
  //otherwise?
end; //tiWaitTimerTimer


//===== Form Events... Open, Activate, Close, etc. ==========
procedure Tldn032f1.FormCreate(Sender: TObject);
var dfIniFile:TIniFile;//"df" in name from "datafile".
begin
//Next two just good practice. Not essential to using 1-Wire
application.title:='LDN032';//Pop-up on taskbar tab
caption:='LDN032- 1-Wire demostration. Version: '+vers;//Shows in title bar, main window

//tiWaitTimer concerned with....
//  1) WaitABit: dubious "let some time pass" mechanism (which gives 1-Wire
//           tture sensors time to complete a temperature reading.
tiWaitTimer.enabled:=false;

//tiReadRepeatedly is simply for making the application read the
//   temperature sensor repeatedly. I have no qualms about the way
//   it is used.
tiReadRepeatedly.enabled:=false;
boReadingRepeatedly:=false;
liCycles:=0;
liEvents:=0;//Count of events reported... "Started"/ warnings/
   //errors, etc... anything, essentially, passed to "concise"
   //channel. Keeping this count accurate sufficient reason to
   //do all such writing via a dedicated procedure, channel,
   //but other advantages also arise.

//--------------------------------------------------------------
//Read from ini file, or, ini file absent, use defaults hard-coded here.
//Note: There are OnChange handlers on many of the edit boxes

dfIniFile:=TIniFile.Create(ExtractFilePath(Application.ExeName)+kIniFileName);

with dfIniFile do begin
   ePortNum.text:=ReadString('Port','Number','99');
   eAdapterType.text:=ReadString('Port','AdapterType','99');

   //chip IDs can have '.'s in them (only), to aid readability...
   //(Has been noted, UserGuide.htm.
   eChipID0.text:=ReadString('Chip','ID-Chip A','1111.2222.3333.4444');
   //eChipID1.text:=ReadString('Chip','ID-Chip B','1111222233334444');
   sTmp:=ReadString('View','Show Raw Values','Y');

   //Determine whether raw values displayed. Anything beginning
   //  'Y' or 'y' will do to turn this on.
   if uppercase(sTmp[1])='Y' then cbShowRawValues.checked:=true//no ; here
        else cbShowRawValues.checked:=false;

   //Set length of delay between "halves" of reading tture.
   //600 is too short, at least sometimes.
   //800 works, at least sometimes, but may be pushing the chip's limit.
   //(Consequences of using "more than enough" (1600?) not entirely clear.)
   eWaitBetweenHalvesOfTtureRead.text:=
       ReadString('Timings','Tture Conversion Allowance','1000');
   eSecsBtwReads.text:=
       ReadString('Timings','Secs Between Reads','1');

   //It is quite simple to put the necessary stuff here, and in FormClose,
   //  to make the application remember the posn and size of the windows
   //  between sessions. See...
   //      http://sheepdogguides.com/lut/lt2Nc.htm
   //  for details.

   end;//with...

dfIniFile.Free;

//qTO DO: prepare way for data and error log files.
//qTO DO: "start of session" entries into both.
//qTO DO: One? Both? Only write in batches?

//End of "Read from ini..."

//buTmpTestThing.visible:=false;

end;

procedure Tldn032f1.FormActivate(Sender: TObject);
begin
boSessionValid:=true;//Initialize
laCycles.caption:=kCyclesRoot+'0';
meMsgs.lines.clear;
meMsgsConcise.lines.clear;
//-----------------------------------------------
//---- Connect to 1-Wire subroutines, adapter

(*Any time you are using TMEX, the software in the
"master", i.e. the PC (or other) "in charge" of
the MicroLan has to "connect" with the Dallas
supplied routines, and establish that an adapter
is present. You have to tell the subroutines what
type of adapter is being used, and, in many cases,
"where" it is, i.e. which port (in the pre-TPC/IP
days sense, i.e. COM1? COM2?, etc, if using a
serial port)

This involved calling TMExtentedStartSession and
TMSetup. In most cases, you do this "once and for
all" at the start of the application's execution.

You should do a TMEndSession as the application
shuts down.

The two calls, among other things establish a
"session handle". It is, at heart, a number, and
you use it with subsequent calls to other TMEX
subroutines.

There is a TMValidSession to test if something
has happened to "break" the "connection", i.e.
to check that the session handle, equipment, etc
are still "good".

Don't worry about the "Extended" in
"TMExtendedStartSession". Although the old,
not-extension call is still available, no one
would use it(? afaik) in any new work.

NOT required by 1-Wire, but used extensively in
most of my progrmams: A boolean, boValidSession in
this application, to say "things are good, carry
on. "boValidSession" is perhaps a bad name, as
I use it to cover more than just the session
being good. When all is running smoothly,
boValidSession remains true. If a problem is
encountered, it is set false, and now pointless
stuff is skipped over. boValidSession might be
set false when a single chip fails to respond, but
the be set true again so that another chip can
be tried, in an application which involves several
1-Wire chips. I.e., it might be set false for a
less severe fault than a failure of THE SESSION.
*)

//Before the following will execute properly,
//the application must have filled...
//  siPortNum, and
//  siAdapterType


///VVVVVVVVVVVVVVVVVVVVVVVVVV
//Quite a lot happens in the course of the call about
//  to occur. See tmex_support unit to understand better.
//qDo notes here.

boSessionValid:=boTryToStart(liSessHdl);

if boSessionValid then begin
   //turn off "fix it" message
   SwitchOptionsForReading(1);//turn ON
   end//no ; here
  else begin
   //turn on "fix it" message
   SwitchOptionsForReading(0);//turn OFF
   end;//"else" of if boStartParamsOkay...

  meMsgs.lines.insert(0,'Version of Tmex_Support unit used in this is: '+sVerTmex_Support);
  PostConcise('Version of Tmex_Support unit used in this is: '+sVerTmex_Support);
//MOVE TO central ROUTINE and DO SIMILAR FOR ALL SUPPORT UNITS

//If all started up okay, then put application in "read repeatedly" mode...
if boSessionValid then begin
   buTakeTtureClick(self);//Do one "manually", for immediate display,
   //because first from following comes at end of first timeout of "wait
   //xx seconds between taking readings".
   buReadRepeatedlyToggleClick(self);
   end;

end; //FormActivate

procedure Tldn032f1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var dfIniFile:TInifile;
begin
tiReadRepeatedly.enabled:=false;
if boSessionValid then begin
   siTmp:=TMEndSession(liSessHdl);
    //TMEndSession does return error codes, which, eventually,
    //   should be looked at, dealt with... but as we are
    //   exiting app at this point, I doubt they are of
    //   much importance.
    //We may pass through here when liSessHdl is no longer valid,
    //   but we didn't know that, and haven't had a chance to
    //   change boSessionValid to false. boSessionValid is still
    //   useful, for saving us going into things that need a handle
    //   when we DO know that the session handle is no longer valid.
   end;

dfIniFile:=TIniFile.Create(ExtractFilePath(Application.ExeName)+kIniFileName);
with dfIniFile do begin
  WriteString('Port','Number',ePortNum.text);
  WriteString('Port','AdapterType',eAdapterType.text);
  WriteString('Chip','ID-Chip A',eChipID0.text);
  //WriteString('Chip','ID-Chip B',eChipID1.text);
  WriteString('Timings','Tture Conversion Allowance',
      eWaitBetweenHalvesOfTtureRead.text);
  WriteString('Timings','Secs Between Reads',
      eSecsBtwReads.text);

  if cbShowRawValues.checked then sTmp:='Yes'//no ; here
      else sTmp:='No';
  WriteString('View','Show Raw Values',sTmp);

  end;//with...
dfIniFile.Free;

showmessage('(Tmp for debugging) "FormClose" executed.');

end;//FormClose

//======== Sundry TKB subroutines =================

procedure Tldn032f1.SwitchOptionsForReading(bOneForOn_ZeroForOff:byte);
//
begin
if bOneForOn_ZeroForOff=1 then begin
     buTakeTture.enabled:=true;
     buReadRepeatedlyToggle.enabled:=true;
     end//no ; here
  else begin
     buTakeTture.enabled:=false;
     buReadRepeatedlyToggle.enabled:=false;
     end//else
end;

function Tldn032f1.boTryToStart(var liTmpL:longint):boolean;
var boWillBeResult:boolean;
begin

udrTMExtenStrtSessPlusTMSetupTmp:=
    udrTryTMExendedStartSessionPlusTMSetup(siPortNum,
       siAdapterType);

boWillBeResult:=udrTMExtenStrtSessPlusTMSetupTmp.boSessionValid;

if boWillBeResult=false then begin
       showmessage('Encountered Error code: '+
         inttostr(udrTMExtenStrtSessPlusTMSetupTmp.liSessHdl)+chr(13)+
         ' Attempt to set up session failed.'+chr(13)+
         'Concise message was: '+
            udrTMExtenStrtSessPlusTMSetupTmp.sMsgConcise+chr(13)+
         'Verbose message was: '+
            udrTMExtenStrtSessPlusTMSetupTmp.sMsgVerbose+' Clsing now.');
         boTmp:=true;
       //You cannot... not that, any longer, I wish to, put a "close"
       //inside a repeat...until... the loop won't terminate. Nor does
       //application.terminate work any better. Nor the two of them together.
       end;

liSessHdl:=udrTMExtenStrtSessPlusTMSetupTmp.liSessHdl;

//Attach time to messages HERE, otherwise unit tmex_support needs
//   LOTS of stuff better kept at this level...
udrTwoStrings_Tmp:=udrTwoStrings_CodedTime(now);

   udrTwoStrings_tmp2.sPass0:=udrTwoStrings_Tmp.sPass0+
       udrTMExtenStrtSessPlusTMSetupTmp.sMsgConcise;
   udrTwoStrings_tmp2.sPass1:=udrTwoStrings_Tmp.sPass1+
       udrTMExtenStrtSessPlusTMSetupTmp.sMsgVerbose;
   PostTwoStrings(kP2both,udrTwoStrings_tmp2);

//^ ^ ^ That's the 1-Wire/TMEX session established. It
//will normally be "good" indefinately. Unplugging an
//adapter might "break" a session. Replacing it with
//one of a different sort certainly would.
//------ ^  ^  ^  ^  ^  ----------------------------------

result:=boWillBeResult;
end;

procedure Tldn032f1.PostConcise(sTmpL:string);
//This to be called whenever a concise message to be posted,
//so that all such can be done the same way. (Having this
//procedure also helps with keeping the count of events reported
//accurate!)
begin
inc(liEvents);
meMsgsConcise.lines.Insert(0,inttostr(liEvents)+': '+sTmpL);
end;

procedure Tldn032f1.IncCylesAndReDisplay;
begin
inc(liCycles);
laCycles.caption:=kCyclesRoot+inttostr(liCycles);
end;

procedure Tldn032f1.PostTwoStrings(bSw:byte;udrTwoStrings_tmpL:TudrTwoStrings);
//Posts two strings, typically error messages, to two places.
//This is supposed to be used for all such postings, so that destinations
//   can be changed for ALL such messages by simple tweaks to this
//   subroutine alone.
//The first string (.sPass0) should be a concise version of the message,
//and the second can be more verbose.
//
//bSw is a switch... if neither bit 0 or 1 set: Send to neither
//                   if 1: Send only to concise
//                   if 2: Send only to verbose
//                   if 3: Send to both.
//Human friendly constants... kP2neit/ kP2conc/ kP2verb/ k2Both
//  exist for those.
begin
//Send the concise version to the right place... in due course,
//   include ATTEMPT to send to an errors/warnings log file.
//   (That will have it's own, separate, "turn on/ turn off"
//   mechanism, which will deal gracefully with messages sent
//   to it, even when logging is not turned on.)
if (bSw and 1)=1 then begin
   meMsgs.lines.insert(0,udrTwoStrings_tmpL.sPass0);
   end;
//Send the verbose version to the right place...
if (bSw and 2)=2 then begin
   PostConcise(udrTwoStrings_tmpL.sPass1);
   end;

end;//PostTwoStrings

procedure Tldn032f1.WaitABit(wMS: word);
//Once upon a time... maybe still... WaitABit and WaitBriefly
//   were almost identical. Do not, however, merge them into
//   one general purpost "Wait" procedure, as the day may come
//   when WaitABit is replaced by an entirely different, better
//   mechanism even though WaitBriefly carries on as before.
//   (Waiting briefly... 10ms??) is no big deal. The periods of
//   time that have to pass during WaitABit (1500ms?) are more
//   problematic with a multitasking OS.)
//wTmp holds how many millisecond the program should wait for.
//It must not make Windows "hang", nor be too demanding of system
//resources.
//The wait interval will be approximate.
//I am not at all convinced that this "wait a bit" has been done
//   well. It "works"... but how robust the solution is, how sparing
//   of system resources, I am not sure.

//Timer should be left NOT enabled at end of WaitABit.
const MsPerNap=150;

var wMsDone:word;

begin

//I was, unitl 26 Aug 16, using a simple sleep(wMS), but found
//that while other things worked nicely, this was laggy... couldn't
//scroll message boxed during a WaitABit, for instance.
//
//Brealing up into muliple sleeps was an attempt to fix that.

//http://www.freepascal.org/docs-html/rtl/sysutils/sleep.html
//says...
//Sleep suspends the execution of the program for the specified
//number of milliseconds (milliseconds). After the specified
//period has expired, program execution resumes.

wMsDone:=0;

repeat

sleep(MsPerNap);//I don't know a lot about sleep... but it seems to
//do what I need, minus MOST of the problems my "solution" had.
//DS032 is still "frozen" while sleeping... but "Quit"s are
//processed as soon as the nap is over, and other apps work
//normally during the nap.... I think. Early days. Not exhaustively
//tested.
application.processmessages;
wMsDone:=wMsDone+mSPerNap;

until wMsDone>=wMS;

(*
  //This was my way to make the prgm "WaitABit"....

  tiWaitTimer.enabled:=false;
  tiWaitTimer.interval:=131;//Make this too large, and the delay
  //between processmessages becomes too great. Also, the time
  //interval becomes more approximate. Too small, and more
  //processmessages than necessary are executed. Everything else
  //"self-adjusts". This, you might say, determines the "granularlity"
  //of WaitABit.
  siWaitABitTimeouts:=wMS div tiWaitTimer.interval;//Max allowed: 32k
  tiWaitTimer.enabled:=true;
  repeat
     //application.processmessages;//Can't, for instance, make this...
     //if (siWaitABitTimeouts mod 5)=0 then application.ProcessMessages;...
     laDebug.caption:='WaitABit is executing '+IntToStr(siWaitABitTimeouts);
     application.ProcessMessages;//CRUCIAL. There MUST be one in this loop!
  until siWaitABitTimeouts<1;//siWaitABitTimeouts decremented by timer's timeout.

  tiWaitTimer.enabled:=false;
  laDebug.caption:='WaitABit timeout complete.';

*)

end;//WaitABit

procedure Tldn032f1.WaitBriefly(wMS: word);
//Once upon a time... maybe still... WaitABit and WaitBriefly
//   were almost identical. Do not, however, merge them into
//   one general purpost "Wait" procedure, as the day may come
//   when WaitABit is replaced by an entirely different, better
//   mechanism even though WaitBriefly carries on as before.
//   (Waiting briefly... 10ms??) is no big deal. The periods of
//   time that have to pass during WaitABit (1500ms?) are more
//   problematic with a multitasking OS.)
//wTmp holds how many millisecond the program should wait for.
//It must not make Windows "hang", nor be too demanding of system
//resources.
//The wait interval will be approximate.
//I am not at all convinced that this "wait a bit" has been done
//   well. It "works"... but how robust the solution is, how sparing
//   of system resources, I am not sure.

//Timer should be left NOT enabled at end of WaitABit.

begin
  tiWaitTimer.enabled:=false;
  tiWaitTimer.interval:=11;//Make this too large, and the delay
  //between processmessages becomes too great. Also, the time
  //interval becomes more approximate. Too small, and more
  //processmessages than necessary are executed. Everything else
  //"self-adjusts". This, you might say, determines the "granularlity"
  //of WaitABit.
  siWaitABitTimeouts:=wMS div tiWaitTimer.interval;//Max allowed: 32k
  tiWaitTimer.enabled:=true;
  repeat
     //application.processmessages;//Can't, for instance, make this...
     //if (siWaitABitTimeouts mod 5)=0 then application.ProcessMessages;...
     laDebug.caption:='WaitBriefly is executing '+IntToStr(siWaitABitTimeouts);
     application.ProcessMessages;//CRUCIAL. There MUST be one in this loop!
  until siWaitABitTimeouts<1;//siWaitABitTimeouts decremented by timer's timeout.

  tiWaitTimer.enabled:=false;
  laDebug.caption:='WaitBriefly timeout complete.';
end;//WaitBriefly

function Tldn032f1.TakeTtureReading:longint;
//A huge procedure, and the heart of this application's machinery.

//Returns a tture in centidegrees Kelvin, or 2147483647 (max value a
//   longint variable can hold), a rogue reserved to
//   indicate "bad value, do not display"

//TURN INTO A FUNCTION??... which returns a udr with boSuccessful,
    //where-error-occured info if not, and value if was.
//The job has been started (udrTryTMReadScratchPadAndValidate) MORE
    //could, should be done... e.g. a "TurnOffAllChipsButOne" routine.
//
//MAKE IT POSS to use this one function to access many chips.
//
//WRITE UP PRELIM REQ's // EXIT STATE.... is it in here or elsewhere
//  that connection to TMEX services made??
//
//If turning into a funtion, be careful about how error messages
//  reach outside world. A mixed economy **IS** (?) possible??


var boErrSeen:boolean;
    bTtureLo,bTtureHi,bChecksumSent,
      b0,b1,b2,b3,b4,b5,b6,b7:byte;
    wTtureCentiK:word;//Used briefly in conversion for display

//const kWaitBetweenTouchByte=1;//Controls how long the "WaitBriefly"s here
  //delay the program. They MAY not be necessary... I put them in when
  //trying to fix something that was caused by something else. But they
  //MAY be necessary, and may NOT be doing any harm. But they may be.
  //In other words, if you find problems, be suspicious!


begin //TakeAndDisplayReading
    boErrSeen:=false;//Establish an initial value.

    //First: Fill the elements of siaROM....

    //The numbers drawn from eChipID0 tell the software
    //the ID of the temperature sensing chip you claim
    //to be on your MicroLan.
    //
    //The software, at the time I write this messy comment could
    //only work with chips having the family code "$28". 1-Wire Viewer
    //told me that my chip's ID was 2E00.0001.34D9.E328
    //(The dot's in that mean nothing more than the commas
    //in, say, 1,432,376, or the dashes in a telephone number,
    //e.g. 1-888-555-1212. They are there only to aid readabilty.
    //
    //** MY ** chip's ID... your's WILL be different... was:
    //2e00.0001.34d9.e328
    //Use the ini file or the edit box to CHANGE what sChipID is set to.
    //
    //siaRom[0]: When this is NOT zero, when TMRom is
       //  called, it will WRITE what is in siaROM 0-7 to the
       //  "right place" in the state buffer for further
       //  TMEX subroutine calls.
       //
       //When siaROM[0] IS zero, TMRom READS FROM the
       //  "right place" in the state buffer, TO the
       //  elements of the siaROM array.
       //
       //The TMEX API Help document says that after
       //  a read... "(the array siaROM will) have
       //  unique ROM (i.e. the chip's ID) in it.
       //  siaROM[0] will have the family code...
       //I don't know if that is true or false...
       //  but I DO know (it cost me three hours)
       //  that when you use TMRom to WRITE a
       //  chip ID to the state buffer, you should
       //  put the chip's family code in siaROM[0];,
       //  the penultimate byte of the chip ID in
       //  siaROM[1], and so on.
       //(As I type this, after the three hours,
       //  I realize that what I tried first was
       //  only "logical" in SOME ways. Filling
       //  the array in the other order is logical
       //  in ways which had not occured to me. Sigh.)
       //
       //The Help doc goes on...
       //  "and siaROM[7] has the 8-bit CRC". This is
       //  suspect. If that's so, a byte of the chip ID
       //  has been lost. I suspect that the CRC is
       //  in fact in siaROM[8]. (Perhaps the 8-bit
       //  CRC is the end byte of what I call "the
       //  chip ID... THAT would make sense, and "solve"
       //  the "problem" of the documentation being
       //  "wrong". Eureka. I've struggled with that
       //  worry for about 30 years. This possible
       //  "answer" occured to me 21 Aug 16. Sigh.

(*

IN THE TMEX API Help Doc I SAW that....

*after* *Reading*.... "(the array, siaROM
will) have unique ROM (i.e. the chip's ID) in it.
siaROM[0] will have the family code..."

I was confused... maybe still am... and thought
that indicated that THAT WHEN WRITING the ID,
you fill the buffer IN THE OTHER ORDER. ARGH.

(Or maybe I was filling it in the opposite direction
than I thought I was? Sigh.)
*)

   //Chip family code goes in siaRom[0]
   //Remember that at one
   //   point, I was filling siaRom twice...
   FillSiaRom(0);//The parameter is for a later
   //stage in this application's development,
   //when it will be set up to read from multiple
   //tture sensors. The parameter will tell the
   //software which chip is to be read.
   siTmp:=siInTmexSupp_TMRom(liSessHdl);
   if siTmp<0 then begin
      //Documentation does not cover the case of a result
      //  OF zero... only of 1 (all well), and values
      //  of LESS THAN zero. See TMEX API Help doc, for
      //  the meanings of the various possible error values.
        meMsgs.lines.insert(0,'TMRom call returned an error:'+
           inttostr(siTmp));//Need to do similar, with concise
           //msg, to meMsgsConcise,  to prepare way for day
           //when concise messages go to log file.
        //qDo... convert to PostTwo...^^
        boErrSeen:=true;
        end;

(*1 of 2 ways to access the chip... faster, than TMStrongAccess,
  but doesn't check chip is actually on the MicroLan!

THIS WOULD NEED RE-WRITE TO REFLECT MOVE OF stabuff to TMEX_SUPPORT
  UNIT... BUT THAT has been done.... SEE FURTHER DOWN PAGE WHERE
  A CALL OF A TMACCESS HELD IN TMEX_SUPPORT UNIT is USED!

    if boErrSeen=false then begin //first try the next bit...
        siTmp:=TMAccess(liSessHdl,@stabuffForOneWire);
        //TMgAccess has a "built in" reset of the MicroLan, done 1st.
       if siTmp=0 then begin
            meMsgs.lines.insert(0,'TMAccess call returned zero, '+
              'indicating that no chips were seen on the MicroLan.');
            boErrSeen:=true;
            end;
        if siTmp<0 then begin
            meMsgs.lines.insert(0,'TMAccess call returned error code '+
              inttostr(siTmp));
            boErrSeen:=true;
            end;
        //only other case documented is siTmp=1, indicating that
        //at least one chip is on MicroLan... not necessarily the
        //one we asked for, though. But if what we asked for is
        //present, it "has been selected"... i.e. all the others
        //have been "put to sleep", and will "slumber" until the
        //the next reset. (There is a reset "within" TMAccess.)
    end;//... of first "try next bit"
*)

(*2nd of 2 ways to access the chip we want. Slower but better in that
    it checks to see the chip is actually available.*)
    if boErrSeen=false then begin //first try the next job...
        siTmp:=siInTmexSupp_TMStrongAccess(liSessHdl);
        //TMStrongAccess has a "built in" reset of the MicroLan, done 1st.

        if siTmp=0 then begin
            udrTwoStrings_Tmp:=udrTwoStrings_CodedTime(now);
            //MAYBE DO A ROUTINE FOR THIS SORT OF THING?? qFind16823b
            //First concise version...
            sTmp:=udrTwoStrings_Tmp.sPass0+' at loc16823a TMStrongAccess '+
                'error code says chip not present.';
            PostConcise(sTmp);
            //In due course, send sTmp to data file, too.
            //qDo... convert to PostTwo...^^
            //
            //Second verbose version...
            sTmp:=udrTwoStrings_Tmp.sPass1+
                'TMStrongAccess call returned zero, indicating '+
                'that the specified chip not on the MicroLan.';
            meMsgs.lines.insert(0,sTmp);

            boErrSeen:=true;
            end;
        if siTmp<0 then begin
            meMsgs.lines.insert(0,'TMStrongAccess call returned error code '+
              inttostr(siTmp));
            boErrSeen:=true;
            end;
        //only other case documented is siTmp=1, indicating that
        //at least one chip is on MicroLan... not necessarily the
        //one we asked for, though. But if what we asked for is
        //present, it "has been selected"... i.e. all the others
        //have been "put to sleep", and will "slumber" until the
        //the next reset. (There is a reset "within" TMAccess.)
    end;//... of first "try next bit"


//if BoErrSeen is still false, we now have our chip selected. The
//code above here will be the same for whatever chip we
//want to work with. The code BELOW here is specific
//to a particular type of 1-Wire chip, in this case, a DS18B20.

(*end "alternate way to access the chip*)

//----------------------------------------------------------------
//The DS18B20 is a little tedious to work with, but its function
//(temperature sensing) is so widely useful, that I decided to use
//it in this example, anyway.
//
//With the DS18B20 (and other temperature sensing chips) we have
//to go through the whole 1-Wire "access the chip/ do things with it"
//business TWICE! (The first pass tells the chip to TAKE a temperature
//reading. The second says "tell the Master what you saw".
//
//You have to arrange for a short (in human terms, long in computer
//  operation terms) delay between the two blocks of code.
//
//With many Dallas 1-Wire chips, you have an option to use them via
//"parasitic" power, or with power supplied directly. The code example
//below was written for a chip operating on parasitic power.
//
//(You ARE operating on parasitic power if there are only two wires
//connected to your DS18B20... the "data" line, and the ground, both
//going off to the adapter plugged into "the master", the PC "running
//things".)

    if boErrSeen=false then begin //try 1st chip specific job...
        //Send message to chip telling it to take a reading
        siTmp:=TMTouchByte(liSessHdl,$44);
        if siTmp=255 then begin
                meMsgs.lines.insert(0,'TMTouchByte call returned report '+
                  'that the MicroLan was shorted at time of $44 command.');
                boErrSeen:=true;
                end;
        if siTmp<0 then begin
                meMsgs.lines.insert(0,'TMTouchByte call returned error '+
                  'code '+inttostr(siTmp)+' at time of $44 command. '+
                  'See TMEX Hardware Specific '+
                  'Error Return Code for interpretation.');
                boErrSeen:=true;
                end;
        //Else, siTmp holds a byte returned by the call, but it is of
        //  little interest, not being an error code.
        end;//... of first "try 1st chip specific bit"

//At this point, for reading ttures, when we are using parasitic
//power, we need to set the 1-Wire level to strong pull up, and wait a bit.
    if boErrSeen=false then begin
        siTmp:=TMOneWireLevel(liSessHdl,0,1,0);
        if siTmp<0 then begin
                meMsgs.lines.insert(0,'TMOneWireLevel call to set '+
                  'strong pull up returned error '+
                  'code '+inttostr(siTmp)+' See TMEX API Help '+
                  'for interpretation.');
                boErrSeen:=true;
                end;
        end;


//I'm not at all convinced that my "WaitABit" does this by the
//best (or even good) means... but it seems, up to a point, to "work"....
    if boErrSeen=false then WaitABit(wWaitBetweenHalvesOfTtureRead);

//Return 1-Wire level to normal value.
    if boErrSeen=false then begin
        siTmp:=TMOneWireLevel(liSessHdl,0,0,0);
        if siTmp<0 then begin
                meMsgs.lines.insert(0,'TMOneWireLevel call to clear '+
                  'strong pull up returned error '+
                  'code '+inttostr(siTmp)+' See TMEX API Help '+
                  'for interpretation.');
                boErrSeen:=true;
                end;
        end;

//========================================================
//(As ever: If boErrSeen still false...)
//Start "Access chip, etc"... and tell it to report readings.

(*By this point, we should have made a conversion, due to
code above here.

FETCHING the value out of the chip requires us to go back to the
beginning, reset the MircoLan, read the value out of the chip, which
it will still be holding, awaiting our return to fetch it. Sigh.

It *MAY* NOT actually be necessary to refill the elements
of siaROM. But I didn't want to take a chance that they
might have become corrupted... say during the call of TMRom?*)

//Fill siaRom again. (See more detailed notes above.)
//If this second "fill" removed from code, be sure to revise
//   comment further up, which currently mentions this
//   second "fill".

if boErrSeen=false then begin
FillSiaRom(0);//The parameter is for a later
//stage in this application's development,
//when it will be set up to read from multiple
//tture sensors. The parameter will tell the
//software which chip is to be read.
siTmp:=siInTmexSupp_TMRom(liSessHdl);
if siTmp<0 then begin
  //Documentation does not cover the case of a result
  //  OF zero... only of 1 (all well), and values
  //  of LESS THAN zero. See TMEX API Help doc, for
  //  the meanings of the various possible error values.
    meMsgs.lines.insert(0,'TMRom call returned an error:'+
       inttostr(siTmp));
    boErrSeen:=true;
    end;
   (*End of refill ROM*)
end;

if boErrSeen=false then begin //now do TMAccess again...
//We've recently done a TMStrongAccess, so TMAccess should
//suffice here. (Faster, but doesn't check chip is actually
//present.)
    siTmp:=siInTmexSupp_TMAccess(liSessHdl);
    //TMAccess does a reset of the MicroLan first.

    if siTmp=0 then begin
        meMsgs.lines.insert(0,'2nd TMAccess call returned zero, '+
          'indicating that no chips were seen on the MicroLan.');
        boErrSeen:=true;
        end;
    if siTmp<0 then begin
        meMsgs.lines.insert(0,'2nd TMAccess call returned error code '+
          inttostr(siTmp));
        boErrSeen:=true;
        end;
    //only other case documented is siTmp=1, indicating that
    //at least one chip is on MicroLan... not necessarily the
    //one we asked for, though. But if what we asked for is
    //present, it "has been selected"... i.e. all the others
    //have been "put to sleep", and will "slumber" until the
    //the next reset. (There is a reset "within" TMAccess.)
end;//... of first "try next bit"

//if BoErrSeen is still false, we now have our chip selected again.
//... so begin the chip-specific code for the "read what was seen" part...
if boErrSeen=false then begin
    udrReadScratchpadTmp:=udrTryTMReadScratchPadAndValidate(liSessHdl);
    boErrSeen:=udrReadScratchpadTmp.boErrSeenL;//Fill this level's boolean.
    bTtureLo:=udrReadScratchpadTmp.b0;
    bTtureHi:=udrReadScratchpadTmp.b1;

{Only first two of these, for read DS18B20, used...

BUT, for other uses of udrTryTMReadScratchPadAndValidate,
   REMEMBER THEY ARE AVAILABLE!!!!...

b0:=udrReadScratchpadTmp.b0;
b1:=udrReadScratchpadTmp.b1;
b2:=udrReadScratchpadTmp.b2;
b3:=udrReadScratchpadTmp.b3;
b4:=udrReadScratchpadTmp.b4;
b5:=udrReadScratchpadTmp.b5;
b6:=udrReadScratchpadTmp.b6;
b7:=udrReadScratchpadTmp.b7;
}



(* HOW TO STICK TIME ON THINGS.....
udrTwoStrings_Tmp:=udrTwoStrings_CodedTime(now);
udrTwoStrings_tmp.sPass0:=udrTwoStrings_Tmp.sPass0+'- code loc16825a: ReadScratchpad checksum failed.';
udrTwoStrings_tmp.sPass1:=udrTwoStrings_Tmp.sPass1+'- at location 16825a, the Read '+
   'Scratchpad bytes, when subjected to checksum algorithm, returned '+
   'a value that did not match the checksum sent by the 1-Wire chip.';
PostTwoStrings(kP2both,udrTwoStrings_tmp);
*)



(*Same code fine for READING tture with DS1820 and DS18B20...
  **BUT** > > How the two bytes returned from the chip needs to be
     INTERPRETED differentlt for the two chips.

  Family codes for 1820 and DS18B20: $10 and $28 respectively.

  DS048 has routines for both, and has a "switch" like...
  if (baDMLRomID[bIdx,0]=$10) then rsTmp:=rRawToC(bTmp,bTmp2);
  if (baDMLRomID[bIdx,0]=$28) then rsTmp:=rRawToC18B20(bTmp,bTmp2);

  (The "rRawToC18B20" was taken from DS048's code with little
   hassle.)
*)

//Now use the temperature reading from the sensor, converting
//  from the "raw" "Dallas numbers" to human-friendly numbers.
 end;

    //Really ought to be part of display part, but makes passing
    //  result messy....
    if boErrSeen=false then begin //report readings, if boErrSeen false
    if cbShowRawValues.checked then //no "begin
         ReadingsF1.meReadings.lines.insert(0,'^^^The raw values from the chip were: '+
             inttostr(bTtureHi)+'  '+inttostr(bTtureLo)+
             ' (Basis of value shown above)');
        //if cbShowRaw... then... had no "begin". So no "end"


//We have to take those two bytes, and "do things" to turn them
//  into a reading in Celcius degrees. That's "easy",
//  compared to a direct conversion to Fahrenheit degrees.
//  If we want Fahrenheit, our best bet is to convert to C
//  first, and convert from there, if we want to.

//Also note, as hinted at above: At least two of the 1-Wire
//  temperature sensor chips work just like one
//  another UP TO HERE... but from here, you convert from the
//  two bytes the chip gives you to Celcius degrees with different
//  algorithms. The one presented here works for DS18B20 chips. See
//  the datasheet for that chip and the datasheet for your chips to see
//  whether your chips encode the data in the same way.

//The Dallas engineers made their choices for good reasons... but it
// gave us a little extra work, if we want degrees Celcius.
//I'm going to make another choice that still leaves us not using
// degrees C, but which I hope you will agree has its merits. I
// WILL show you how to DISPLAY the reading from your chip in degrees C.

//My choice is to convert values in bTtureLo, bTtureHi to a temperature
//  expressed in HUNDRETHS of degrees Kelvin. The Dallas
//  chips sort of work in Celcius, which is Kelvin +273.15 Using
//  centi-degrees K (inside the program) means that you
//  don't need the hassles of floating point numbers, or signed numbers.
//  (You can, of course, display the ttures in any units, with a simple
//  conversion occurring just before the tture appears.)
//
//Range: If a 16-bit unsigned variable is used for the tture, you can
//  express any tture from absolute zero to 655.35 Kelvin, which is about
//  382 Celcius...  which will, I hope, "do"?

//While both the DS1820 (family code $10) and the DS18B20 (family code $28)
//  are "driven" the same way, you have to interpret the results differently,
//  hence the inclusion of the chip's family code in what follows...

   bTmp:=0;
   if copy(sChipID[bTmp],15,2)<>'28' then begin
      showmessage('The chip ID currently specified by the hard coded '+
        'constant near the top of the program has a "chip family code" '+
        'which this program cannot work with. (It can only handle chips '+
        'from family code $28, i.e. DS18B20s. Alterations to make it '+
        'capable of dealing with family code $10 would not be difficult.) '+
        'Application will close.');//THIS (27 Aug 16, 22:08)needs work
      close;
      end;

   bTmp:=0;
   wTtureCentiK:=wRawTTureToCentiK(bTtureLo,bTtureHi,
                    strtoint('$'+copy(sChipID[bTmp],15,2)));

   (*MAYBE... why?....
   IMPLEMENT THE FOLLOWING TWO USES OF ERROR CODES (are they?) ALREADY WRITTEN INTO FUNCTION...
   if wRawTTureToCentiK:=65535 then general fail
   if wRawTTureToCentiK:=65534 then invalid chip family      *)

   //wRawTTureToCentiK can also return valid results if
   //The third parameter is $10, I believe. The "if code <>$28" code
   //   just above here is there simply because I don't have TIME
   //   to TEST that belief at the moment!

   //showmessage(inttostr(wTtureCentiK));


   end;//prepare value in CentiK, if boErrSeen false

   //WAS PART OF THIS... now moved out...
   //ReadingsF1.meReadings.lines.insert(0,sFixedWidth(9,' ',sTtureCfrmCentiK(wTtureCentiK))+
   //       ' degrees C: ~'+sBarGraph(15,37,40,(wTtureCentiK-27315)/100)+'~');
   if boErrSeen then result:=2147483647//no ; here (2147483647= max longint can be.)
       else result:=wTtureCentiK;

end;//procedure TakeAndDisplayReading;

procedure Tldn032f1.DisplayTtureReading(liTmpL:longint);
//A tture in centidegrees K should be passed to this.
//2147483647 (max allowed value) reserved for indicating: "bad value, do not
//   display"
begin
    if liTmpL<>2147483647 then begin
    ReadingsF1.meReadings.lines.insert(0,sFixedWidth(9,' ',sTtureCfrmCentiK(liTmpL))+
       ' degrees C: ~'+sBarGraph(15,37,40,(liTmpL-27315)/100)+'~');
    end;

end;//DisplayTtureReading


end.
